<template>
  <div class="restaurant" :class="{ loading: !restaurant }" @click="preorder()">
    <template v-if="restaurant">
      <div
        class="thumbnail"
        :style="{ 'background-image': `url(${thumbnail})` }"
      ></div>
      <div class="detail">
        <h3 class="name">{{ restaurant.company.name }}</h3>
        <span class="address">{{ restaurant.buildingAddress }}</span>
        <span class="cate">{{
          $t(`restaurantTypes.${restaurant.restaurantType}`)
        }}</span>
        <div v-if="disabled" class="disabled-label">
          {{ $t("restaurant.preorderClosed") }}
        </div>
        <div class="times" ref="times">
          <div class="tags">
            <span class="tag">{{ $t("restaurant.preorderButton") }}</span>
          </div>
        </div>
      </div>
    </template>

    <template v-else>
      <div class="thumbnail lp"></div>
      <div class="detail">
        <h3 class="name"><span class="lp"></span></h3>
        <span class="address"><span class="lp"></span></span>
        <span class="cate"><span class="lp"></span></span>
        <div class="times" ref="times"><span class="lp"></span></div>
      </div>
    </template>
  </div>
</template>

<script>
import moment from "moment";
import { mapState } from "vuex";
import BScroll from "better-scroll";
import wheel from "@/lib/better-scroll-vertical-wheel";

export default {
  props: {
    restaurant: {
      type: Object,
      required: false
    },

    disabled: {
      type: Boolean,
      required: false
    },

    preorder: {
      type: Function,
      default: () => {},
      required: false
    },

    date: {
      type: String
    }
  },

  data() {
    return {
      dragging: false
    };
  },

  computed: {
    ...mapState(["isMobile"]),

    thumbnail() {
      return this.isMobile
        ? this.restaurant.thumbnail(200, 200, 90)
        : this.restaurant.thumbnail(500, 375, 95);
    }
  },

  methods: {
    enableScrolling() {
      if (this.$refs.times && !this.timesScroll) {
        this.timesScroll = wheel(
          new BScroll(this.$refs.times, {
            scrollX: true,
            click: true,
            eventPassthrough: "vertical"
          })
        );
      }
    }
  },

  mounted() {
    this.$nextTick(() => {
      this.enableScrolling();
    });
  },

  updated() {
    this.$nextTick(() => {
      this.enableScrolling();
      this.timesScroll && this.timesScroll.refresh();
    });
  },

  destroyed() {
    this.timesScroll && this.timesScroll.destroy();
  }
};
</script>

<style lang="scss" scoped>
.restaurant {
  padding: 12px 0 12px 10px;
  display: flex;
  border-bottom: 1px $color-sky-grey solid;
  cursor: pointer;
  transition: all 0.2s;

  &:hover {
    background: $color-genesis-white;
  }

  @include media-breakpoint-up(md) {
    display: block;
    padding: 10px;
    margin: 15px;
    background: $color-white;
    border: none;

    &:hover {
      background: $color-white;
      box-shadow: 0 6px 12px 0 rgba(0, 0, 0, 0.1);
    }
  }
}

.thumbnail {
  width: 110px;
  height: 110px;
  flex-shrink: 0;
  flex-grow: 0;
  margin-right: 16px;
  background-size: cover;

  @include media-breakpoint-up(md) {
    width: 100%;
    height: auto;
    padding-bottom: 75%;
  }
}

.detail {
  overflow: hidden;

  @include media-breakpoint-up(md) {
    overflow: visible;
  }
}

.name {
  display: block;
  font-size: 18px;
  font-weight: bold;
  margin: 2px 0 0;
  line-height: 1.8em;

  .lp {
    width: 100px;
    margin-bottom: 4px;
  }
}

.address {
  display: block;
  font-size: 13px;

  .lp {
    width: 180px;
    margin-bottom: 4px;
  }
}

.cate {
  color: $color-primary-grey;
  font-size: 13px;

  .lp {
    width: 80px;
  }
}

.times {
  width: 100%;
  overflow: hidden;
  margin-top: 4px;

  .lp {
    width: 100px;
  }

  @include media-breakpoint-up(md) {
    width: calc(100% + 10px);
  }
}

.tags {
  display: inline-block;
  white-space: nowrap;
  cursor: grab;
  user-select: none;

  &.dragging {
    cursor: grabbing;
  }
}

.tag {
  display: inline-block;
  border-radius: 2px;
  color: $color-white;
  background: $color-skm-red;
  padding: 0 10px;
  line-height: 26px;
  margin-right: 10px;
  cursor: pointer;
}

.disabled-label {
  color: $color-pigeon-grey;
  padding: 6px 0;
  font-size: 14px;
}
</style>
